### Want to contribute to doddle-model but not sure where to start?
You've come to the right place :). There are many ways to contribute and writing code is only one of them. It's important to note that all kinds of contributions are equally appreciated. Below we name just a few, if you have some other idea, don't hesitate to get in [touch](https://gitter.im/picnicml/doddle-model).

#### Use doddle-model in your own work
Seriously, just by using the project your are helping a ton! If you encounter any problems, you can talk to us on [gitter](https://gitter.im/picnicml/doddle-model) or open a new issue [here](https://github.com/picnicml/doddle-model/issues).

#### Write a blog post
This is a big one. If you used `doddle-model` to develop a cool model, writing about it helps us enormously with the exposure. [Here](https://towardsdatascience.com/recognising-handwritten-digits-with-scala-9829d035f7bc)'s one example published on Medium.

#### Write / improve the documentation
There's never enough of documentation and we know that! If you think we are lacking in that regard (and we are) feel free to open a PR that adds or improves the documentation.

#### Write examples / tutorials
We have a repository full of [examples](https://github.com/picnicml/doddle-model-examples) on how to use `doddle-model`. And with examples... well it's similar as with documentation: we need moar! Some other ideas / projects are available below:
- [SMS spam classification](https://github.com/picnicml/sms-spam-ham)
- [serving a model in an Apache Beam pipeline](https://github.com/picnicml/doddle-beam-example)
- [serving system for pre-trained models](https://github.com/picnicml/doddle-serving)
- [benchmarking performance of implementations](https://github.com/picnicml/doddle-benchmark)

#### Help shape the roadmap
Be sure to take a look at the [roadmap](https://github.com/picnicml/doddle-model/wiki/Roadmap) to get a better understanding about the direction in which we are heading. Your input on that is also welcome.

#### Write some code
Finally, if you want to dive deep into the source code and write some new features or fix a simple bug (like that's a thing) there are some points that you should read first:
- for a list of typeclasses that together define the estimator API see the [typeclasses directory](https://github.com/picnicml/doddle-model/tree/master/src/main/scala/io/picnicml/doddlemodel/typeclasses)
- concerning the code style, [PayPal Scala Style](https://github.com/paypal/scala-style-guide) and [Databricks Scala Guide](https://github.com/databricks/scala-style-guide) are roughly followed (note that a maximum line length of 120 characters is used)
- be sure to also check the [roadmap](https://github.com/picnicml/doddle-model/wiki/Roadmap) and the [kanban board](https://github.com/picnicml/doddle-model/projects/1)
